﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace FGEnhancements.Models
{
    public class DataSource
    {
        private static readonly string[] Countries = "Austria,Belgium,Canada,Denmark,Estonia,Finland,Germany,Hungary,Ireland,Japan,Korea,Lebanon,Mexico,Norway,Portugal,Qatar,Romania,Spain,Turkey,Ukraine,Venezuela,Zaire".Split(',');
        public static List<CountryData> GetDataSource(int count = 10)
        {
            List<CountryData> data = new List<CountryData>();
            Random r = new Random((int)DateTime.Now.ToFileTimeUtc());
            for(int i = 1; i <= count; i++)
            {
                var cnt = new CountryData
                {
                    ID = i,
                    Name = GetCountries(),
                    Sales = r.Next(10000),
                    Expenses = r.Next(10000)
                };
                data.Add(cnt);
            }
            return data;
        }

        private static string GetCountries()
        {
            var c = new List<string>();
            var r = new Random((int)DateTime.Now.ToFileTimeUtc());
            int cnt = r.Next(8) + 1, start = r.Next(Countries.Length - 1);
            for (var i = 0; i < cnt; i++)
            {
                c.Add(Countries[(i + start) % Countries.Length]);
            }
            return string.Join(", ", c);
        }
    }

    public class CountryData
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public double Sales { get; set; }
        public double Expenses { get; set; }
        public double Profit
        {
            get
            {
                return Sales - Expenses;
            }
        }
    }
}
